#pragma once

#include "ItemSkill.h"
#include "ItemType.h"

class PlayerHandItemType : public ItemType
{
protected:
    void loadSuperItemSkill(
        ItemSkill* zSkill, Framework::StreamReader* zReader) const override;
    void saveSuperItemSkill(const ItemSkill* zSkill,
        Framework::StreamWriter* zWriter) const override;

public:
    PlayerHandItemType();
    Item* createItem() const override;
    ItemSkill* createDefaultItemSkill() const override;
};

class PlayerHandLevelUpRule : public ItemSkillLevelUpRule
{
public:
    PlayerHandLevelUpRule();
    void applyOn(ItemSkill* zSkill) override;
};

class PlayerHandSkill : public ItemSkill
{
public:
    PlayerHandSkill();
    bool use(Entity* zActor, Item* zUsedItem, Block* zTarget) override;
    bool use(Entity* zActor, Item* zUsedItem, Entity* zTarget) override;
};